class Table(object):
    def __init__(self, fields, data=None):
        self.fields = fields
        if data != None:
            self.data = data
        else:
            self.data = []

    def load(self, f):
        for line in f:
            l = eval('['+line.replace('\n','').replace('\r','')+']')
            if len(l) < len(self.fields):
                l += [None]*(len(self.fields)-len(l))
            self.add_row(l)

    def save(self, f):
        for row in self.data:
            f.write(repr(row)[1:-1]+'\n')

    def add_row(self, row):
        self.data += [row]

    def update_field(self, rownum, field, newvalue):
        fieldidx = self.fields.index(field)
        self.data[rownum][fieldidx] = newvalue

    def get_row(self, rownum):
        row = {}
        for i in range(len(self.fields)):
            row[self.fields[i]] = self.data[rownum][i]
        return row

    def select_field(self, field, value):
        results = []
        fieldidx = self.fields.index(field)
        for i in range(len(self.data)):
            if self.data[i][fieldidx] == value:
                results.append(i)
        return results

    def get_field(self, nrow, field):
        return self.data[nrow][self.fields.index(field)]

    def nrows(self): return len(self.data)

class Database(object):
    def __init__(self):
        self.tables = {}

    def add_table(self, tablen, table):
        self.tables[tablen] = table

    def get_table(self, tablen):
        return self.tables[tablen]
