import wx
from struct import unpack

# might be moved in a graphic module
def unpack_rgb15(v):
    b = ((v >> 10)%32)*8
    g = ((v >> 5)%32)*8
    r = (v%32)*8
    return chr(r)+chr(g)+chr(b)

def indexed_to_rgb(s, pal):
    rgbs = ''
    for c in s:
        rgbs += pal[ord(c)]
    return rgbs

def indexed_to_alpha(s):
    alpha = ''
    for c in s:
        if ord(c) == 0:
            alpha += '\x00'
        else:
            alpha += '\xff'
    return alpha


def draw_text(dc, text, x0, y0, width_table, main_glyph_table,
              extra_glyph_table, pal):
    chars = map(lambda c: unpack('<H', c)[0], [text[2*i:2*i+2] 
                                               for i in range(len(text)/2)])
    x, y = x0, y0
    for char in chars:
        sp = char >> 12
        val =char % (1 << 12)
        if sp == 2 or sp == 8:
            if sp == 2:
                # main glyph table            
                glyph = main_glyph_table.glyphs[val]
            elif sp == 8 and extra_glyph_table is not None:
                glyph = extra_glyph_table.glyphs[val]
            else:
                continue
            s = glyph.pixels
            bmp = wx.BitmapFromBuffer(16, 16, indexed_to_rgb(s,pal),
                                      indexed_to_alpha(s))
            dc.DrawBitmap(bmp, x, y, True)
            x += glyph.width
        elif sp == 6:
            if val == 0:
                x = x0
                y += 16
