import Image
from struct import unpack
from drawing import unpack_rgb15

class Graphic(object):
    def __init__(self, f):
        w, h = unpack('<II', f.read(8))
        iminfo = unpack('<I', f.read(4))[0]
        if iminfo == 4:
            imsize = unpack('<I', f.read(4))[0]
            self.image = Image.new('RGB', (w*8, h*8))
            for j in range(h):
                for i in range(w):
                    s = ''
                    for c in f.read(32):
                        pixd = ord(c)
                        s += chr((pixd % 16) * 16)*3
                        s += chr((pixd >> 4) * 16)*3
                    if len(s) < 8*8*3: return

                    self.image.paste(Image.fromstring('RGB', (8,8), s),
                                     (i*8, j*8))

                            
