import os
import sys
from struct import pack, unpack
from fileinfile import FileInFile

class IdxAndPak(object):
    def __init__(self, idx, pak):
        #print 'new pak'
        pak.seek(0)
        idx.seek(0)
        self.pak = pak
        self.files = []

        idx.read(4)

        entries = idx.read()
        nentries = len(entries) / 6

        for i in range(nentries): 
    #        a, b = unpack('<II', f.read(3)+'\x00'+f.read(3)+'\x00')
            enti = 6*i
            entni = 6*(i+1)
            a = unpack('<I', entries[enti:enti+4])[0]
            ab = ((a << 5) % (2 ** 32)) >> 8
            v3 = a % 8
            if v3 != 0:
#                b = unpack('<H', entries[enti+4:enti+6])[0]
#                c = unpack('<I', entries[entni:entni+4])[0]
#                d = b + (c >> 27)
#                v8 = (d << 7) % (2 ** 32)
#                vc = 0 # don't know have to step debug this
                v8 = 0
            else:
                c = unpack('<I', entries[entni:entni+4])[0]
                d = ((c << 5) % (2 ** 32)) >> 8
                v8 = (d-ab) << 2
                vc = 0
            v4 = (ab) << 2
    #        print i, hex(v3), hex(v4), hex(v8), hex(vc)

#            self.filesinfo.append((v4, v8, v3)
            if v3 == 0:
                self.files.append(FileInFile(self.pak, v4, v8))
            else:
                self.files.append(None)

    def get_file(self, id):
        return self.files[id]

    def nfiles(self): return len(self.files)

    def set_file(self, id, f):
        self.files[id] = f

    def repack(self):
        def align16(d):
            return (d + 0x1F) & ~0x1f
 
        idx = ''
        pak = ''
        idx += '\x00'*4
        of = 0
        for f in self.files:
            if f == None: c = 7
            else: c = 0
            idx += pack('<I', 2*of+c)[:3]
            idx += '\x00\x00\x00'

            if f == None:
                continue

            sz = f.size
            pak += f.read()
            pak += '\x00'*(align16(of+sz)-len(pak))
            of = align16(of+sz)

        return idx, pak
