# setup.py
from distutils.core import setup
import sys
import py2exe
import os

sys.argv.append("py2exe")

ltables = []
for i in range(2000):
	if os.path.exists('tables/trans_table%04d.csv' % i):
		ltables += ['tables/trans_table%04d.csv' % i]

excludes = ["pywin", "pywin.debugger", "pywin.debugger.dbgcon",
	    "pywin.dialogs", "pywin.dialogs.list",
	    "Tkconstants","Tkinter","tcl",
	    ]

##################################################  ##############
# The manifest will be inserted as resource into your .exe.  This
# gives the controls the Windows XP appearance (if run on XP ;-)
#
# Another option would be to store it in a file named
# test_wx.exe.manifest, and copy it with the data_files option into
# the dist-dir.
#
manifest_template = '''
<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<assembly xmlns="urn:schemas-microsoft-com:asm.v1" manifestVersion="1.0">
<assemblyIdentity
    version="5.0.0.0"
    processorArchitecture="x86"
    name="ffta2_editor"
    type="win32"
/>
<description>%(prog)s Program</description>
<dependency>
    <dependentAssembly>
        <assemblyIdentity
            type="win32"
            name="Microsoft.Windows.Common-Controls"
            version="6.0.0.0"
            processorArchitecture="X86"
            publicKeyToken="6595b64144ccf1df"
            language="*"
        />
    </dependentAssembly>
</dependency>
</assembly>
'''
 
RT_MANIFEST = 24

ffta2_editor = {
	'script' : "main.py",

	'other_resources' : [(RT_MANIFEST, 1, manifest_template)],
	'dest_base' : 'ffta2_editor',
	}
	
setup(
	name="FFTA2 Editor",
	options = {"py2exe": {"compressed": 1,
			      "optimize": 2,
			      "bundle_files": 1,
			      "excludes": excludes}},
	
	zipfile = None,
	data_files = [
		('.', ['gui_layout', 'logo.png', 'editor.cfg']),
		('tables', ltables),
		('graphics', []),
		('preview', ['preview/preview_abilities.png', 'preview/preview_area.png',
			     'preview/preview_subarea.png', 'preview/preview_bigtext.png',
			     'preview/preview_talk.png', 'preview/preview_redbox.png']),
		('font', ['font/font_new.png']),
		('font/extra', []),
		],
	
	windows = [ffta2_editor],
	)
