# -*- coding: utf-8 -*-
from struct import pack, unpack
def get_table():
    table = {}
    for i in range(10):
        table[0x20a4+i] = chr(ord('0')+i)
    for i in range(26):
        table[0x20ae+i] = chr(ord('A')+i)
        table[0x20c8+i] = chr(ord('a')+i)
    table[0x20c8+26] = '.'
    table[0x20c8+27] = '「'
    table[0x20c8+28] = '」'
    table[0x20c8+29] = '行'

#  82 9e |    ぁ あ ぃ い ぅ う ぇ え ぉ お か が き ぎ く 
#  82 ae | ぐ け げ こ ご さ ざ し じ す ず せ ぜ そ ぞ た 
#  82 be | だ ち ぢ っ つ づ て で と ど な に ぬ ね の は 
#  82 ce | ば ぱ ひ び ぴ ふ ぶ ぷ へ べ ぺ ほ ぼ ぽ ま み 
#  82 de | む め も ゃ や ゅ ゆ ょ よ ら り る れ ろ ゎ わ 
#  82 ee | ゐ ゑ を ん                                     
#  83 3f |    ァ ア ィ イ ゥ ウ ェ エ ォ オ カ ガ キ ギ ク 
#  83 4f | グ ケ ゲ コ ゴ サ ザ シ ジ ス ズ セ ゼ ソ ゾ タ 
#  83 5f | ダ チ ヂ ッ ツ ヅ テ デ ト ド ナ ニ ヌ ネ ノ ハ 
#  83 6f | バ パ ヒ ビ ピ フ ブ プ ヘ ベ ペ ホ ボ ポ マ ミ 
#  83 80 | ム メ モ ャ ヤ ュ ユ ョ ヨ ラ リ ル レ ロ ヮ ワ 
#  83 90 | ヰ ヱ ヲ ン ヴ ヵ ヶ   

    # Hiragana
    hiragana = u' あ\'いぅうぇえぉおかがきぎく' + \
        u'ぐけげこごさざしじすずせぜそぞた' + \
        u'だちぢっつづてでとどなにぬねのは' + \
        u'ばぱひびぴふぶぷへべぺほぼぽまみ' + \
        u'むめもゃやゅゆょよらりるれろわ'+ \
        u'をん'
    
    c = 0x2000
    for glyph in hiragana:
        table[c] = glyph.encode('utf-8')
        c += 1

    # Katakana
    katakana = u'ァアィイゥウェエォオカガキギク' + \
        u'グケゲコゴサザシジスズセゼソゾタ' + \
        u'ダチヂッツヅテデトドナニヌネノハ' + \
        u'バパヒビピフブプヘベペホボポマミ' + \
        u'ムメモャヤュユョヨラリルレロワヲンヴ,。ー'
    
    c = 0x2050
    for glyph in katakana:
        table[c] = glyph.encode('utf-8')
        c += 1

    ft = {}


    ft[24] = u'定森丘緑地山洞窟湿原'

    ft[25] = u'廃坑平断崖遺跡砂漠下'

    ft[26] = u'道禁域白魔士黒弓使闘'

    ft[27] = u'用心棒忍者幻術青狩人'

    ft[28] = u'導竜騎守護神殿砲撃獣'

    ft[29] = u'時錬金裏学調合精霊赤'

    ft[30] = u'法剣召喚動物銃曲芸風'

    ft[31] = u'水茶生成体空賊踊子吟'

    ft[32] = u'遊詩優?:(隠)出入'

    ft[33] = u'口想尾草乙女針聖毒消'

    ft[34] = u'目薬万能紙結晶破片逆'

    ft[35] = u'転応急処置挑発見盗主'

    ft[36] = u'役座足狙腕射抜不死昇'

    ft[37] = u'天介抱降伏勧告浄化斬'

    ft[38] = u'波居打奥義式・炎雷参'

    ft[39] = u'凍滅四殺魂放投木遁火'

    ft[40] = u'土解呪忘却夜戦咆哮嵐'

    ft[41] = u'息怪音油宣追払助言所'

    ft[42] = u'岩砕疾迅回拳裂蘇邪印'

    ft[43] = u'冬眠連続暗身秘雄気練'

    ft[44] = u'装弾固台笑示疑鬼手態'

    ft[45] = u'書氷光闇影縫根止失声'

    ft[46] = u'悪夢寒封潜羊匹%理振'

    ft[47] = u'暴走歌友達紹輪歯車銀'

    ft[48] = u'円盤電池塊虹色磁石黄'

    ft[49] = u'!反骨一意大衝自然力'

    ft[50] = u'工無機族舞二名特製次'

    ft[51] = u'元指先再報復接誘確認'

    ft[52] = u'永遠怒突食窒液粘着沈'

    ft[53] = u'共活性愛融溶威呼覚記'

    ft[54] = u'憶深吸血超凝視線恐怖'

    ft[55] = u'包丁剛来兜割補寄仲間'

    ft[56] = u'当引込取創種圧縮蜜侵'

    ft[57] = u'攻獄海嘯裁爆玉牙右南'

    ft[58] = u'極北々界吐香粉差泉命'

    ft[59] = u'絶黙鐘異計羽月酒爪賢'

    ft[60] = u'得巨角妖小瀕切矢返肉'

    ft[61] = u'収避武器属強貫通持両'

    ft[62] = u'刀流費半減免疫統効盾'

    ft[63] = u'備可必満知識延長警戒'

    ft[64] = u'全重技僧祈祷近衛惑仕'

    ft[65] = u'野塵臭触排除淵作業情'

    ft[66] = u'屋愛付現代供世横文字'

    ft[67] = u'@縦度号話‐町夏日総'

    ft[68] = u'初級交渉係臨量点集中'

    ft[69] = u'分十上王方内本以団乱'

    ft[70] = u'君国的味制変姿皇弱冥'

    ft[71] = u'率葉貴傷敵様要立形城'

    ft[72] = u'移型刺員新前相部家楽'

    ft[73] = u'去後好最思質実場進速'

    ft[74] = u'編明…/~+×&*↑'

    ft[75] = u'↓→亜阿安位囲衣飲雨'

    ft[76] = u'運雲英鉛殴価加嫁果花'

    ft[77] = u'貸壊廻改灰階貝外鎧格'

    ft[78] = u'殻隔革刊完感丸顔危起'

    ft[79] = u'亀菊宮求球究距凶狂琴'

    ft[80] = u'具靴群経軽激決穴絹験'

    ft[81] = u'源個古己虎五御語功向'

    ft[82] = u'幸広甲紅鉱高刻混左査'

    ft[83] = u'採細材罪桜雑三産残支'

    ft[84] = u'氏私糸紫治漆社蛇灼錫'

    ft[85] = u'殊珠樹周宗修秋終柔宿'

    ft[86] = u'祝純順勝商少章象丈嬢'

    ft[87] = u'常杖状飾植職審真親刃'

    ft[88] = u'吹数勢星正説雪千専染'

    ft[89] = u'船選素槍争送増即束村'

    ft[90] = u'多太対耐袋退竪探短端'

    ft[91] = u'段男値遅虫徴鳥直低帝'

    ft[92] = u'艇笛鉄典伝徒倒桃?頭'

    ft[93] = u'同銅徳独熟年燃派背配'

    ft[94] = u'倍箱髪判板範番皮飛美'

    ft[95] = u'百表品夫布斧浮服福憤'

    ft[96] = u'兵柄募宝胞帽防墨麻末'

    ft[97] = u'密脈鳴面模毛耗戻紋門'

    ft[98] = u'勇有与陽翼羅螺落利離'

    ft[99] = u'律旅了料良隣冷烈蓮和'

    ft[100] = u'瞑縛逃敗【】遣画財組'

    for k in ft:
        b = 0x2000+(k-1)*10
        for c in ft[k]:
            table[b] = c.encode('utf-8')
            b += 1

    return table

def get_specials():
    specials = {}
    specials['X_button'] = 0x60cb
    specials['R_button'] = 0x612b
    specials['carriage_return'] = 0x6000
    specials['book_anim'] = 0x632b
    return specials

def reverse(rt):
    table = get_table()
    specials = get_specials()
    s = ''
    i = 0

    t = rt.decode('utf-8')

    while i < len(t):
        rc = t[i]
        c = rc.encode('utf-8')
        if c == '{':
            i += 1
            a = t[i:i+2]
            i += 2
            b = t[i:i+2]
            i += 3
            s += chr(eval('0x'+a))
            s += chr(eval('0x'+b))
        elif c == '[':
            i += 1
            k = ''
            while t[i] != ']':
                k += t[i]
                i += 1
            i += 1
            if k in specials:
                s += pack('<H',specials[k])
            else:
                print 'Unrecognized special character named '+k
        else:
            for k in table:
                if c == table[k]:
                    s += pack('<H', k)
                    break
            i += 1
    return s

def lookup(s):
    nchar = len(s)/2
    t = ''
    table = get_table()
    specials = get_specials()
    for n in unpack('<'+'H'*nchar, s):
        if n in table:
            t += table[n]
        else:
            bspec = False
            for k in specials:
                if specials[k] == n:
                    t += '['+k+']'
                    bspec = True
                    break
            if not bspec:
                t += '{%02x%02x}' % (n % 256, n >> 8)
    return t


def hexdump_with_table(f):
    res = ''
    i = 0
    f.seek(0)
    while True:
        v = f.read(16)
        if len(v) == 0:
            break
        s = '[%08x]  ' % (i*16)
        for k in range(4):
            for l in range(4):
                if 4*k+l < len(v):
                    s += '%02x' % ord(v[4*k+l])
            s += ' '
        s += '  |'
        s += lookup(v)
        s += '|'
        res += s+'\n'
        i += 1
        if len(v) < 16:
            break
        if i*16 > 100000:
            break
    return res

if __name__ == '__main__':
#    table = get_table()
#    c = 0
#    s = '|-\n'
#    for k in table:
#        s += '|'+hex(k)+':'+table[k]+'\n'
#        c += 1
#        if c == 8:
#            c = 0
#            s += '|-\n'
#    print '{|class="wikitable" width="100%"\n'+s+'\n|}'
    s = '「{aa65} d'
    rs = reverse(s)
    print s
    print map(hex,map(ord,rs))
